import React, {useEffect, useState} from "react";
export default function SonComponent2(props= {
    msg:"",
    changeMsg:(_)=>{}
}){

    // 模拟 componentDidMount
    useEffect(() => {
        // 在组件挂载后执行的操作
        console.log('[挂载] SonComponent2 组件后执行的操作');
        return () => {
            // 在组件卸载前执行的操作
            console.log('[卸载] SonComponent2 组件 前执行的操作');
        };
    }, []); // 空数组意味着仅在组件挂载时执行一次

    const [state, setState] = useState({
        msg: "son msg",
        tmp: "",
        count: 0,
    })

    // 模拟 componentDidUpdate
    useEffect(() => {
        // 当count更新时执行的操作
        console.log('SonComponent2 组件后更新，执行的操作:', state);
    }, [state]); // 依赖于 state，当 state 变化时执行

    function changeMsg(){
        let target = `parent msg 被修改 (${++state.count})`
        setState({
            ...state,
            tmp: props.changeMsg(target)
        })
    }

    function revokeChangeMsg(){
        let count = state.count
        setState({
            ...state,
            count: count > 0 ? --count : 0,
            tmp: props.changeMsg(state.tmp)
        })
    }


    return <div style={{border: '1px solid', width: '80%', overflow: 'auto'}}>
        子组件2

        <div style={{border: '1px solid', width: '80%', overflow: 'auto', margin: 'auto'}}>
            <div>
                {state.msg}
            </div>

            <hr/>

            <div>
                {props.msg}

                <div>
                    <button onClick={changeMsg}>修改msg</button>
                    <button onClick={revokeChangeMsg}>撤销操作</button>
                </div>
            </div>
        </div>
    </div>

}
